/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __SN_WATCHER_INTERFACE_H__
#define __SN_WATCHER_INTERFACE_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.kde.StatusNotifierWatcher */

#define TYPE_SN_WATCHER_INTERFACE (sn_watcher_interface_get_type ())
#define SN_WATCHER_INTERFACE(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), TYPE_SN_WATCHER_INTERFACE, SnWatcherInterface))
#define IS_SN_WATCHER_INTERFACE(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), TYPE_SN_WATCHER_INTERFACE))
#define SN_WATCHER_INTERFACE_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), TYPE_SN_WATCHER_INTERFACE, SnWatcherInterfaceIface))

struct _SnWatcherInterface;
typedef struct _SnWatcherInterface SnWatcherInterface;
typedef struct _SnWatcherInterfaceIface SnWatcherInterfaceIface;

struct _SnWatcherInterfaceIface
{
  GTypeInterface parent_iface;



  gboolean (*handle_register_status_notifier_host) (
    SnWatcherInterface *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_service);

  gboolean (*handle_register_status_notifier_item) (
    SnWatcherInterface *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_service);

  gboolean  (*get_is_status_notifier_host_registered) (SnWatcherInterface *object);

  gint  (*get_protocol_version) (SnWatcherInterface *object);

  const gchar *const * (*get_registered_status_notifier_items) (SnWatcherInterface *object);

  void (*status_notifier_host_registered) (
    SnWatcherInterface *object);

  void (*status_notifier_item_registered) (
    SnWatcherInterface *object,
    const gchar *arg_service);

  void (*status_notifier_item_unregistered) (
    SnWatcherInterface *object,
    const gchar *arg_service);

};

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SnWatcherInterface, g_object_unref)
#endif

GType sn_watcher_interface_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *sn_watcher_interface_interface_info (void);
guint sn_watcher_interface_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void sn_watcher_interface_complete_register_status_notifier_item (
    SnWatcherInterface *object,
    GDBusMethodInvocation *invocation);

void sn_watcher_interface_complete_register_status_notifier_host (
    SnWatcherInterface *object,
    GDBusMethodInvocation *invocation);



/* D-Bus signal emissions functions: */
void sn_watcher_interface_emit_status_notifier_item_registered (
    SnWatcherInterface *object,
    const gchar *arg_service);

void sn_watcher_interface_emit_status_notifier_item_unregistered (
    SnWatcherInterface *object,
    const gchar *arg_service);

void sn_watcher_interface_emit_status_notifier_host_registered (
    SnWatcherInterface *object);



/* D-Bus method calls: */
void sn_watcher_interface_call_register_status_notifier_item (
    SnWatcherInterface *proxy,
    const gchar *arg_service,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean sn_watcher_interface_call_register_status_notifier_item_finish (
    SnWatcherInterface *proxy,
    GAsyncResult *res,
    GError **error);

gboolean sn_watcher_interface_call_register_status_notifier_item_sync (
    SnWatcherInterface *proxy,
    const gchar *arg_service,
    GCancellable *cancellable,
    GError **error);

void sn_watcher_interface_call_register_status_notifier_host (
    SnWatcherInterface *proxy,
    const gchar *arg_service,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean sn_watcher_interface_call_register_status_notifier_host_finish (
    SnWatcherInterface *proxy,
    GAsyncResult *res,
    GError **error);

gboolean sn_watcher_interface_call_register_status_notifier_host_sync (
    SnWatcherInterface *proxy,
    const gchar *arg_service,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
const gchar *const *sn_watcher_interface_get_registered_status_notifier_items (SnWatcherInterface *object);
gchar **sn_watcher_interface_dup_registered_status_notifier_items (SnWatcherInterface *object);
void sn_watcher_interface_set_registered_status_notifier_items (SnWatcherInterface *object, const gchar *const *value);

gboolean sn_watcher_interface_get_is_status_notifier_host_registered (SnWatcherInterface *object);
void sn_watcher_interface_set_is_status_notifier_host_registered (SnWatcherInterface *object, gboolean value);

gint sn_watcher_interface_get_protocol_version (SnWatcherInterface *object);
void sn_watcher_interface_set_protocol_version (SnWatcherInterface *object, gint value);


/* ---- */

#define TYPE_SN_WATCHER_INTERFACE_PROXY (sn_watcher_interface_proxy_get_type ())
#define SN_WATCHER_INTERFACE_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), TYPE_SN_WATCHER_INTERFACE_PROXY, SnWatcherInterfaceProxy))
#define SN_WATCHER_INTERFACE_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), TYPE_SN_WATCHER_INTERFACE_PROXY, SnWatcherInterfaceProxyClass))
#define SN_WATCHER_INTERFACE_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TYPE_SN_WATCHER_INTERFACE_PROXY, SnWatcherInterfaceProxyClass))
#define IS_SN_WATCHER_INTERFACE_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), TYPE_SN_WATCHER_INTERFACE_PROXY))
#define IS_SN_WATCHER_INTERFACE_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), TYPE_SN_WATCHER_INTERFACE_PROXY))

typedef struct _SnWatcherInterfaceProxy SnWatcherInterfaceProxy;
typedef struct _SnWatcherInterfaceProxyClass SnWatcherInterfaceProxyClass;
typedef struct _SnWatcherInterfaceProxyPrivate SnWatcherInterfaceProxyPrivate;

struct _SnWatcherInterfaceProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  SnWatcherInterfaceProxyPrivate *priv;
};

struct _SnWatcherInterfaceProxyClass
{
  GDBusProxyClass parent_class;
};

GType sn_watcher_interface_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SnWatcherInterfaceProxy, g_object_unref)
#endif

void sn_watcher_interface_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
SnWatcherInterface *sn_watcher_interface_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
SnWatcherInterface *sn_watcher_interface_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void sn_watcher_interface_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
SnWatcherInterface *sn_watcher_interface_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
SnWatcherInterface *sn_watcher_interface_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define TYPE_SN_WATCHER_INTERFACE_SKELETON (sn_watcher_interface_skeleton_get_type ())
#define SN_WATCHER_INTERFACE_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), TYPE_SN_WATCHER_INTERFACE_SKELETON, SnWatcherInterfaceSkeleton))
#define SN_WATCHER_INTERFACE_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), TYPE_SN_WATCHER_INTERFACE_SKELETON, SnWatcherInterfaceSkeletonClass))
#define SN_WATCHER_INTERFACE_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TYPE_SN_WATCHER_INTERFACE_SKELETON, SnWatcherInterfaceSkeletonClass))
#define IS_SN_WATCHER_INTERFACE_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), TYPE_SN_WATCHER_INTERFACE_SKELETON))
#define IS_SN_WATCHER_INTERFACE_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), TYPE_SN_WATCHER_INTERFACE_SKELETON))

typedef struct _SnWatcherInterfaceSkeleton SnWatcherInterfaceSkeleton;
typedef struct _SnWatcherInterfaceSkeletonClass SnWatcherInterfaceSkeletonClass;
typedef struct _SnWatcherInterfaceSkeletonPrivate SnWatcherInterfaceSkeletonPrivate;

struct _SnWatcherInterfaceSkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  SnWatcherInterfaceSkeletonPrivate *priv;
};

struct _SnWatcherInterfaceSkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType sn_watcher_interface_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SnWatcherInterfaceSkeleton, g_object_unref)
#endif

SnWatcherInterface *sn_watcher_interface_skeleton_new (void);


G_END_DECLS

#endif /* __SN_WATCHER_INTERFACE_H__ */
